
*****************************************************************************
* sub-circuit netlist: Stage 1, ckm, 
*	
*	midpoint of clock: -1.54, hi: -1.34 low: -1.74
*
* block: comp_ms
*****************************************************************************
.model ms_or2 ortwo
+mpk=100 mpinth=-1.465 mpouthi=-1.325 mpoutlo=-1.605

** THE SKEW if controlled by mpinth2 
.model ms_invand2 invand2
+mpk=100 mpinth1=-1.465 mpinth2=-1.54
*+mpk=100 mpinth1=-1.465 mpinth2=-1.575
+mpouthi=-1.325 mpoutlo=-1.605

.model ms_hiand2 hiand2
+mpk=100 mpinth1=-1.465 mpinth2=-1.605
+mpouthi=-1.325 mpoutlo=-1.605

.model mycompms preamp1bit
+mpgain=1.665 mpvhi=-1.325 mpvlo=-1.605 mpalpha=100

.subckt latch_ms in phib out
n1 in phib out1 ms_invand2
c1 out1 0 20f
n2 out phib out2 ms_hiand2
c2 out2 0 20f
n3 out1 out2 out ms_or2
.ends

.subckt	comp_ms	gn	inn	inp	outn	outp	p1	p1b	vcs
+	vcsef	ve	
cinp inp 0 20f
cinn inn 0 20f
rinp inp 0 1.75meg
rinn inn 0 1.75meg
rinx inn inp 1.75meg
n1 inp inn outp11 outn11 mycompms
x1 outp11 p1b outp1 latch_ms
g1 outn1 0 outp1 0 1
i1 outn1 0 2.930
r1 outn1 0 1
roup outp1 outp 41.45
roun outn1 outn 41.45
.ends	comp_ms	


*****************************************************************************
* sub-circuit netlist: Stage 2, ckb
*
*	midpoint of clock: -2.28, hi: -2.08 low: -2.48
*
* block: comp_bc1
*****************************************************************************
.model comp_or2 ortwo
+mpk=100 mpinth=-1.510 mpouthi=-1.315 mpoutlo=-1.705

** THE SKEW if controlled by mpinth2 
.model comp_invand2 invand2
+mpk=100 mpinth1=-1.510 mpinth2=-2.280
*+mpk=100 mpinth1=-1.510 mpinth2=-2.305
+mpouthi=-1.315 mpoutlo=-1.705

.model comp_hiand2 hiand2
+mpk=100 mpinth1=-1.510 mpinth2=-2.340
+mpouthi=-1.315 mpoutlo=-1.705

.subckt latch_comp in phib out
n1 in phib out1 comp_invand2
c1 out1 0 20f
n2 out phib out2 comp_hiand2
c2 out2 0 20f
n3 out1 out2 out comp_or2
.ends

.model mycomp_1 preamp1bit
+mpgain=9.50 mpvhi=-1.315 mpvlo=-1.705 mpalpha=1500

.model mycomp_2 preamp1bit
+mpgain=2.30 mpvhi=-1.315 mpvlo=-1.705 mpalpha=100

.subckt	comp_bc1	gn	inn	inp	outn	outp	p1	p1b
+	vcs	vcs1	vcsef	ve	xn	xp	
cinp inp 0 20f
cinn inn 0 20f
rinp inp 0 200meg
rinn inn 0 200meg
rinx inn inp 200meg
n1 inp inn inp1 inn1 mycomp_1
n2 xp xn xp1 xn1 mycomp_2
n3 inp1 xp1 outp11 comp_or2
x1 outp11 p1b outp1 latch_comp
g1 outn1 0 outp1 0 1
i1 outn1 0 3.020
r1 outn1 0 1
roup outp1 outp 42.95
roun outn1 outn 42.95
.ends	comp_bc1
	
*****************************************************************************
* sub-circuit netlist: Stage 2, ckb
*
*	midpoint of clock: -2.28, hi: -2.08 low: -2.48
*
* block: comp_bc2
*****************************************************************************
.subckt	comp_bc2	gn	inn	inp	outn	outp	p1	p1b
+	vcs	vcs1	vcsef	ve	
cinp inp 0 20f
cinn inn 0 20f
rinp inp 0 200meg
rinn inn 0 200meg
rinx inn inp 200meg
n1 inp inn outp11 outn11 mycomp_1
x1 outp11 p1b outp1 latch_comp
g1 outn1 0 outp1 0 1
i1 outn1 0 3.020
r1 outn1 0 1
roup outp1 outp 42.95
roun outn1 outn 42.95
.ends	comp_bc2	

	
*****************************************************************************
* sub-circuit netlist: Stage 3, ckf
*
*	midpoint of clock: -2.28, hi: -2.08 low: -2.48
*
* block: compsl
*****************************************************************************

** THE SKEW if controlled by mpinth2 
.model comp_invand2_3rd invand2
+mpk=100 mpinth1=-1.510 mpinth2=-2.255
*+mpk=100 mpinth1=-1.510 mpinth2=-2.280
*+mpk=100 mpinth1=-1.510 mpinth2=-2.305
+mpouthi=-1.315 mpoutlo=-1.705

.subckt latch_comp_3rd in phib out
n1 in phib out1 comp_invand2_3rd
c1 out1 0 20f
n2 out phib out2 comp_hiand2
c2 out2 0 20f
n3 out1 out2 out comp_or2
.ends

.subckt	compsl	gn	inn	inp	on	ond	onn	op	opd
+	opp	p1	p1b	vcs	vcsef	ve	
cinp inp 0 20f
cinn inn 0 20f
rinp inp 0 100meg
rinn inn 0 100meg
rinx inn inp 100meg
n1 inp inn op11 on11 mycomp_2
x1 op11 p1b op1 latch_comp_3rd
g1 on1 0 op1 0 1
i1 on1 0 3.020
r1 on1 0 1
g2 opd1 0 op1 0 -1
r2 opd1 0 1
g3 ond1 0 on1 0 -1
r3 ond1 0 1
g4 opp1 0 op1 0 -1
i4 opp1 0 1.315
r4 opp1 0 1
g5 onn1 0 on1 0 -1
i5 onn1 0 1.315
r5 onn1 0 1
rop op1 op 42.95
ron on1 on 42.95
ropd opd1 opd 42.95
rond ond1 ond 42.95
ropp opp1 opp 85.15
ronn onn1 onn 85.15
.ends	compsl	

	
